"""
    Classes for use with asyncio. Requires an additional dependency,
    which should be installed with `pip install sqloquent[asyncql]`.
"""


from .interfaces import (
    AsyncCursorProtocol,
    AsyncDBContextProtocol,
    AsyncJoinedModelProtocol,
    AsyncModelProtocol,
    AsyncQueryBuilderProtocol,
    AsyncRelatedCollection,
    AsyncRelatedModel,
    AsyncRelationProtocol,
)
from .classes import (
    AsyncSqliteContext,
    AsyncSqlModel,
    AsyncJoinedModel,
    AsyncSqlQueryBuilder,
    AsyncDeletedModel,
    AsyncHashedModel,
    AsyncAttachment,
    async_dynamic_sqlmodel,
)
from .relations import (
    AsyncRelation,
    AsyncHasOne,
    AsyncHasMany,
    AsyncBelongsTo,
    AsyncBelongsToMany,
    AsyncContains,
    AsyncWithin,
    async_has_one,
    async_has_many,
    async_belongs_to,
    async_belongs_to_many,
    async_contains,
    async_within,
)